use chrono::{DateTime, Utc};
use serde::{Deserialize, Serialize};

#[derive(Clone, Serialize, Deserialize, Debug)]
pub struct Note {
    pub id: String,
    pub parent_id: Option<String>,
    pub content: String,
    pub location: i64,
    pub kind: String,
    pub creation_date: DateTime<Utc>,
    pub updated_date: DateTime<Utc>,
    pub lastview_date: DateTime<Utc>,
    pub deleted_date: Option<DateTime<Utc>>,
    pub children: Vec<Note>,
}

pub struct Page {
    pub slug: String,
    pub title: String,
    pub creation_date: DateTime<Utc>,
    pub updated_date: DateTime<Utc>,
    pub lastview_date: DateTime<Utc>,
    pub deleted_date: Option<DateTime<Utc>>,
    pub notes: Vec<Note>,
    pub backreferences: Vec<Vec<Note>>,
}
